<?php

class ImageHandler
{
	var $requestfile;
	var $img_file;
	var $img_info;
	var $savename;
	var $thumbname;
	var $mediumname;
	var $fullname;

	function ImageHandler($f = '')
	{
		if ( is_array($f) == true )
		{
			$this->requestfile = $f;
			$this->img_file = $f['tmp_name'];
			$this->img_info = $this->getImageInfo($this->img_file);
			$this->savename = md5(time().$f['name']).'.'.$this->img_info['type'];
			$this->thumbname = SAVE_PATH.'thumb'.DS.
				md5($this->savename).'.'.$this->img_info['type'];
			$this->mediumname = SAVE_PATH.'medium'.DS.
				md5($this->savename).'.'.$this->img_info['type'];
			$this->fullname = SAVE_PATH.'full'.DS.$this->savename;
		}
	}

	function getPhotos(&$result)
	{
		$ret = array();
		while ( !$result->EOF )
		{
			$item = array();
			$field = &$result->fields;
			if ( empty($field) == true ) break;

			$item['id'] = $field['id'];
			$item['title'] = $field['title'];
			$item['memo'] = $field['memo'];
			$file = SAVE_PATH.'full'.DS.$field['filename'];
			$img_info = $this->getImageInfo($file);
			$item['thumb'] = SAVE_URL.'thumb'.DS.
				md5($field['filename']).'.'.$img_info['type'];
			$item['medium'] = SAVE_URL.'medium'.DS.
				md5($field['filename']).'.'.$img_info['type'];
			$item['full'] = SAVE_URL.'full'.DS.$field['filename'];

			array_push($ret, $item);
			$result->MoveNext();
		}
		return $ret;
	}

	function save()
	{
		global $config;
		$this->saveFile($this->thumbname, $config['thumb']);
		$this->saveFile($this->mediumname, $config['medium']);
		move_uploaded_file($this->img_file, $this->fullname);
	}
	function delete($filename)
	{
		$img_info = $this->getImageInfo(SAVE_PATH.'full'.DS.$filename);
		$thumb = SAVE_PATH.'thumb'.DS.md5($filename).'.'.$img_info['type'];
		$medium = SAVE_PATH.'medium'.DS.md5($filename).'.'.$img_info['type'];
		$full = SAVE_PATH.'full'.DS.$filename;
		if ( file_exists($thumb) == true ) unlink($thumb);
		if ( file_exists($medium) == true ) unlink($medium);
		if ( file_exists($full) == true ) unlink($full);
	}
	function saveFile(&$savename, &$size)
	{
		$ImageCreate = 'ImageCreateFrom'.$this->img_info['type'];
		$Image = 'Image'.$this->img_info['type'];
		if ( is_array($size) == false or
			function_exists($Image) == false or
			function_exists($ImageCreate) == false )
			return false;

		// ToDo : save directory permission check
		$src_img = $ImageCreate($this->img_file);
		$new_w = $size['width']; $new_h = $size['height'];
		if ( $size['width'] > $this->img_info['width'] &&
			$size['height'] > $this->img_info['height'] )
		{
			copy($this->img_file, $savename);
			return;
		}
		if ( $this->img_info['width'] >= $this->img_info['height'] )
			$new_h = (int) ( ($this->img_info['height']*$new_w) / $this->img_info['width'] );
		else
			$new_w = (int) ( ($this->img_info['width']*$new_h) / $this->img_info['height'] );
		$dst_img = ImageCreateTrueColor($new_w,$new_h);
		ImageCopyResampled($dst_img,$src_img,0,0,0,0,
			$new_w,$new_h,$this->img_info['width'],$this->img_info['height']);
		$Image($dst_img, $savename);
		ImageDestroy($dst_img);
	}

	function getImageInfo($img)
	{
		$img_type = array(
			1 => "gif",
			2 => "jpeg",
			3 => "png",
			4 => "swf",
			5 => "psd",
			6 => "bmp",
			7 => "tiff", // (intel byte order)
			8 => "tiff", // (motorola byte order)
			9 => "jpc",
			10 => "jp2",
			11 => "jpx",
			12 => "jb2",
			13 => "swc",
			14 => "iff",
			15 => "wbmp",
			16 => "xbm"
		);

		$ret = array();
		$tmp_info = getimagesize($img);
		$ret['width'] = $tmp_info[0];
		$ret['height'] = $tmp_info[1];
		$ret['type'] = $img_type[$tmp_info[2]];
		$ret['attr'] = $tmp_info[3];
		if ( function_exists('exif_read_data') )
		{
			$exif_data = exif_read_data($img);
			$ret['time'] = $exif_data['FILE']['FileDateTime'];
			print $ret['time'];
		}
	
		return $ret;
	}
}
?>
