CREATE TABLE sajin_group (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  user_id INTEGER UNSIGNED NOT NULL default '0',
  name VARCHAR(255) NULL,
  PRIMARY KEY(id),
  INDEX usergroup_FKIndex1(user_id)
);

CREATE TABLE sajin_permission (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  group_id INTEGER UNSIGNED NOT NULL default '0',
  photo_id INTEGER UNSIGNED NOT NULL default '0',
  PRIMARY KEY(id),
  INDEX permission_FKIndex1(photo_id),
  INDEX permission_FKIndex2(group_id)
);

CREATE TABLE sajin_photo (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  user_id INTEGER UNSIGNED NOT NULL default '0',
  date DATETIME NULL,
  filename CHAR(40) NOT NULL,
  title VARCHAR(255) NULL,
  memo TEXT NULL,
  PRIMARY KEY(id),
  INDEX photo_FKIndex1(user_id)
);

CREATE TABLE sajin_tag (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  name VARCHAR(255) NOT NULL default ' ',
  PRIMARY KEY(id),
  INDEX tag_idx_name(name)
);

CREATE TABLE sajin_usergroup (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  group_id INTEGER UNSIGNED NOT NULL default '0',
  user_id INTEGER UNSIGNED NOT NULL default '0',
  PRIMARY KEY(id),
  INDEX user_group_FKIndex1(user_id),
  INDEX user_group_FKIndex2(group_id)
);

CREATE TABLE sajin_user (
  id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  username VARCHAR(255) NULL,
  passwd CHAR(32) NULL,
  email TEXT NULL,
  PRIMARY KEY(id)
);

CREATE TABLE sajin_tag_photo (
  id int(10) unsigned NOT NULL auto_increment,
  photo_id int(10) unsigned NOT NULL default '0',
  tag_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY tag_photo_FKIndex1 (tag_id),
  KEY tag_photo_FKIndex2 (photo_id)
);
